"""
字符集
"""

__all__ = [
    "END_CHAR",
    "DEFAULT",
    "NUMBER",
    "HEX_NUMBER",
    "OCT_NUMBER",
    "END_WORD",
]

# -------------------- Unicode 字符串 --------------------
END_CHAR = "<end>"  # 用于表示结束符的字符串

# -------------------- 特殊字符集 --------------------
DEFAULT = "<default>"  # 用于表示没有特别指定的其他字符集（默认值）

# -------------------- 规则定义字符集 --------------------
# 十进制数
NUMBER = frozenset({"0", "1", "2", "3", "4", "5", "6", "7", "8", "9"})

# 十六进制数
HEX_NUMBER = frozenset({"0", "1", "2", "3", "4", "5", "6", "7", "8", "9",
                        "A", "a", "B", "b", "C", "c", "D", "d", "E", "e", "F", "f"})

# 八进制数
OCT_NUMBER = frozenset({"0", "1", "2", "3", "4", "5", "6", "7"})

# 标识当前词语结束的符号
END_WORD = frozenset({"{", "}", "[", "]", "(", ")", "<", ">", ".", ";", ":", ",", "@", " ", "\n"})
